<!doctype html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1, minimum-scale=1" />
<meta name="generator" content="pdoc 0.7.1" />
<title>models.internals.network_config API documentation</title>
<meta name="description" content="" />
<link href='https://cdnjs.cloudflare.com/ajax/libs/normalize/8.0.0/normalize.min.css' rel='stylesheet'>
<link href='https://cdnjs.cloudflare.com/ajax/libs/10up-sanitize.css/8.0.0/sanitize.min.css' rel='stylesheet'>
<link href="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/styles/github.min.css" rel="stylesheet">
<style>.flex{display:flex !important}body{line-height:1.5em}#content{padding:20px}#sidebar{padding:30px;overflow:hidden}.http-server-breadcrumbs{font-size:130%;margin:0 0 15px 0}#footer{font-size:.75em;padding:5px 30px;border-top:1px solid #ddd;text-align:right}#footer p{margin:0 0 0 1em;display:inline-block}#footer p:last-child{margin-right:30px}h1,h2,h3,h4,h5{font-weight:300}h1{font-size:2.5em;line-height:1.1em}h2{font-size:1.75em;margin:1em 0 .50em 0}h3{font-size:1.4em;margin:25px 0 10px 0}h4{margin:0;font-size:105%}a{color:#058;text-decoration:none;transition:color .3s ease-in-out}a:hover{color:#e82}.title code{font-weight:bold}h2[id^="header-"]{margin-top:2em}.ident{color:#900}pre code{background:#f8f8f8;font-size:.8em;line-height:1.4em}code{background:#f2f2f1;padding:1px 4px;overflow-wrap:break-word}h1 code{background:transparent}pre{background:#f8f8f8;border:0;border-top:1px solid #ccc;border-bottom:1px solid #ccc;margin:1em 0;padding:1ex}#http-server-module-list{display:flex;flex-flow:column}#http-server-module-list div{display:flex}#http-server-module-list dt{min-width:10%}#http-server-module-list p{margin-top:0}.toc ul,#index{list-style-type:none;margin:0;padding:0}#index code{background:transparent}#index h3{border-bottom:1px solid #ddd}#index ul{padding:0}#index h4{font-weight:bold}#index h4 + ul{margin-bottom:.6em}@media (min-width:200ex){#index .two-column{column-count:2}}@media (min-width:300ex){#index .two-column{column-count:3}}dl{margin-bottom:2em}dl dl:last-child{margin-bottom:4em}dd{margin:0 0 1em 3em}#header-classes + dl > dd{margin-bottom:3em}dd dd{margin-left:2em}dd p{margin:10px 0}.name{background:#eee;font-weight:bold;font-size:.85em;padding:5px 10px;display:inline-block;min-width:40%}.name:hover{background:#e0e0e0}.name > span:first-child{white-space:nowrap}.name.class > span:nth-child(2){margin-left:.4em}.inherited{color:#999;border-left:5px solid #eee;padding-left:1em}.inheritance em{font-style:normal;font-weight:bold}.desc h2{font-weight:400;font-size:1.25em}.desc h3{font-size:1em}.desc dt code{background:inherit}.source summary,.git-link-div{color:#666;text-align:right;font-weight:400;font-size:.8em;text-transform:uppercase}.source summary > *{white-space:nowrap;cursor:pointer}.git-link{color:inherit;margin-left:1em}.source pre{max-height:500px;overflow:auto;margin:0}.source pre code{font-size:12px;overflow:visible}.hlist{list-style:none}.hlist li{display:inline}.hlist li:after{content:',\2002'}.hlist li:last-child:after{content:none}.hlist .hlist{display:inline;padding-left:1em}img{max-width:100%}.admonition{padding:.1em .5em;margin-bottom:1em}.admonition-title{font-weight:bold}.admonition.note,.admonition.info,.admonition.important{background:#aef}.admonition.todo,.admonition.versionadded,.admonition.tip,.admonition.hint{background:#dfd}.admonition.warning,.admonition.versionchanged,.admonition.deprecated{background:#fd4}.admonition.error,.admonition.danger,.admonition.caution{background:lightpink}</style>
<style media="screen and (min-width: 700px)">@media screen and (min-width:700px){#sidebar{width:30%}#content{width:70%;max-width:100ch;padding:3em 4em;border-left:1px solid #ddd}pre code{font-size:1em}.item .name{font-size:1em}main{display:flex;flex-direction:row-reverse;justify-content:flex-end}.toc ul ul,#index ul{padding-left:1.5em}.toc > ul > li{margin-top:.5em}}</style>
<style media="print">@media print{#sidebar h1{page-break-before:always}.source{display:none}}@media print{*{background:transparent !important;color:#000 !important;box-shadow:none !important;text-shadow:none !important}a[href]:after{content:" (" attr(href) ")";font-size:90%}a[href][title]:after{content:none}abbr[title]:after{content:" (" attr(title) ")"}.ir a:after,a[href^="javascript:"]:after,a[href^="#"]:after{content:""}pre,blockquote{border:1px solid #999;page-break-inside:avoid}thead{display:table-header-group}tr,img{page-break-inside:avoid}img{max-width:100% !important}@page{margin:0.5cm}p,h2,h3{orphans:3;widows:3}h1,h2,h3,h4,h5,h6{page-break-after:avoid}}</style>
</head>
<body>
<main>
<article id="content">
<header>
<h1 class="title">Module <code>models.internals.network_config</code></h1>
</header>
<section id="section-intro">
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">import glob
import os
from ruamel.yaml import YAML

class Network_Config(object):
    def __init__(self, model_dir = None, config_filepath = None, **kwargs):
        &#34;&#34;&#34;Creates Network_Config object that contains the network parameters and functions needed to manipulate these parameters.
    
        Parameters
        ----------
        model_dir : `str`, optional
            [Default: None] Folder where the model is to be saved/read from
        config_filepath : `str`, optional
            [Default: None] Filepath to the config file that will be loaded
        **kwargs
            For network parameters that are to be changed from the loaded config file

        Attributes
        ----------
        yaml : :class:`ruamel.yaml.YAML`
            YAML class with function needed to read/write YAML files 
        config : `dict`
            Dictionary containing the config parameters
        &#34;&#34;&#34;
        self.yaml=YAML()
        
        # load config file from model_dir
        if config_filepath is not None:
            
            self.config = self.load_config_from_file(config_filepath)
            print(&#34;Loaded config file from {}&#34;.format(config_filepath))
        elif model_dir is not None:
            try:
                self.config = self.load_config_from_model_dir(model_dir)
                print(&#34;Loaded config file from {}&#34;.format(model_dir))
            except:
                print(&#34;Please ensure that config_filepath is set or there is a config file in model_dir&#34;)
                raise
            
        if model_dir is not None:
            # update model_dir in config
            print(&#34;Updating model_dir to {}&#34;.format(model_dir))
            self.update_parameter([&#34;general&#34;, &#34;model_dir&#34;], model_dir)
        
        # overwrite network parameters with parameters given during initialization
        for key, value in kwargs.items():
            self.update_parameter(self.find_key(key), value)
            
        # perform calculations
        self.update_parameter([&#34;model&#34;, &#34;input_size&#34;], self.get_parameter(&#34;tile_size&#34;) + [self.get_parameter(&#34;image_channel&#34;),])
        self.update_parameter([&#34;model&#34;, &#34;batch_size&#34;], self.get_parameter(&#34;batch_size_per_GPU&#34;)) # * self.gpu_count
                  
    ######################
    # Accessors/Mutators
    ######################
    def get_parameter(self, parameter, config = []):
        &#34;&#34;&#34;Output the value from the config file using the given key

        Parameters
        ----------
        parameter : `list` or `str`
            Key or list of keys used to find for the value in the config file
        
        config : `list`, optional
            Used to iterate through nested dictionaries. Required to recursively iterate through neseted dictionary
            
        Returns
        ----------
        value : `str` or `int` or `list`
            Value obtained from the specified key
            
        See Also
        ----------
        find_key : Function to identify the list of keys to address the correct item in a nested dictionary
        &#34;&#34;&#34;
        assert isinstance(parameter, (list, str))
        
        # find for key in nested dictionary
        if isinstance(parameter, str):
            parameter = self.find_key(parameter)
        
        if config == []:
            config = self.config
        if config is None:
            return None
        
        if not parameter:
            return config
        
        return self.get_parameter(parameter[1:], config = config.get(parameter[0]))

    def update_parameter(self, parameter, value, config = None):
        &#34;&#34;&#34;Updates the parameter in the config file using a full addressed list

        Parameters
        ----------
        parameter : `list`
            List of keys that point to the correct item in the nested dictionary
            
        value : `str` or `int` or `list`
            Value that is updated in the nested dictionary
            
        config : `list` or `none`, optional
            Used to iterate through nested dictionaries
            
        Returns
        ----------
        TODO
        &#34;&#34;&#34;
        
        assert type(parameter) is list
                
        if config == None:
            config = self.config
        
        if len(parameter) == 1:
            config.update({parameter[0]: value})
            return config
        return self.update_parameter(parameter[1:], value, config = self.config.get(parameter[0]))

    def find_key(self, key, config = None):
        &#34;&#34;&#34;Find the list of keys to address the correct item in a nested dictionary

        Parameters
        ----------
        key : `str`
            Key that needs to be correctly addressed in a nested dictionary
            
        config : `list` or `none`, optional
            Used to iterate through nested dictionaries
            
        Returns
        ----------
        key : `list`
            Address of the key in the nested dictionary
        &#34;&#34;&#34;
        
        if config == None:
            config = self.config
            
        key_path = []
        for k, v in config.items():
            if k == key:
                return [k]
            elif isinstance(v, dict):
                found_key = self.find_key(key, config = v)
                if found_key is not None:
                    return [k] + found_key
    
    ######################
    # Config IO options
    ######################
    def load_config_from_file(self, file_path):
        &#34;&#34;&#34;Load parameters from yaml file

        Parameters
        ----------
        file_path : `str`
            Path of config file to load
            
        Returns
        ----------
        config : `dict`
            Dictionary containing the config parameters
        &#34;&#34;&#34;

        with open(file_path, &#39;r&#39;) as input_file: 
            config = self.yaml.load(input_file)
            input_file.close()

        return config
    
    def load_config_from_model_dir(self, model_dir):
        &#34;&#34;&#34;Finds for a config file from the model directory and loads it
    
        Parameters
        ----------
        model_dir : `str`
            Folder to search for and load the config file

        Returns
        ----------
        config : `dict`
            Dictionary containing the config parameters
            
        Raises
        ------
        IndexError
            If there are no config file in the model_dir
        &#34;&#34;&#34;
        
        # check if yaml file exists in model_dir
        try:
            list_config_files = glob.glob(os.path.join(model_dir,&#39;*config.yml&#39;))
            if len(list_config_files) &gt; 1:
                print(&#34;Multiple config files found. Loading {}&#34;.format(list_config_files[0]))
            else:
                print(&#34;Config file exists in model directory. Loading {}&#34;.format(list_config_files[0]))
            return self.load_config_from_file(list_config_files[0])
        except IndexError:
            print(&#34;No config file found in model_dir.&#34;)
            raise

    def write_config(self, file_path):
        &#34;&#34;&#34;Writes parameters to yaml file

        Parameters
        ----------
        file_path : `str`
            Path of config file to write to
        &#34;&#34;&#34;
        
        with open(file_path, &#39;w&#39;) as output_file:  
            self.yaml.dump(self.config, output_file)

        output_file.close()
        
        print(&#34;Config file written to: {}&#34;.format(file_path))
    
    def write_model(self, model, file_path):
        &#34;&#34;&#34;Writes parameters to yaml file

        Parameters
        ----------
        model : :class:`Keras.model`
            Keras model that will be parsed and written to a yaml file
        
        file_path : `str`
            Path of model file to write to
        &#34;&#34;&#34;
        
        with open(file_path, &#39;w&#39;) as output_file:  
            output_file.write(model.to_yaml())

        output_file.close()
        
        print(&#34;Model file written to: {}&#34;.format(file_path))</code></pre>
</details>
</section>
<section>
</section>
<section>
</section>
<section>
</section>
<section>
<h2 class="section-title" id="header-classes">Classes</h2>
<dl>
<dt id="models.internals.network_config.Network_Config"><code class="flex name class">
<span>class <span class="ident">Network_Config</span></span>
<span>(</span><span>model_dir=None, config_filepath=None, **kwargs)</span>
</code></dt>
<dd>
<section class="desc"><p>Creates Network_Config object that contains the network parameters and functions needed to manipulate these parameters.</p>
<h2 id="parameters">Parameters</h2>
<dl>
<dt><strong><code>model_dir</code></strong> :&ensp;<code>str</code>, optional</dt>
<dd>[Default: None] Folder where the model is to be saved/read from</dd>
<dt><strong><code>config_filepath</code></strong> :&ensp;<code>str</code>, optional</dt>
<dd>[Default: None] Filepath to the config file that will be loaded</dd>
<dt><strong><code>**kwargs</code></strong></dt>
<dd>For network parameters that are to be changed from the loaded config file</dd>
</dl>
<h2 id="attributes">Attributes</h2>
<dl>
<dt><strong><code>yaml</code></strong> :&ensp;:<code>class</code>:<code>ruamel.yaml.YAML</code></dt>
<dd>YAML class with function needed to read/write YAML files</dd>
<dt><strong><code>config</code></strong> :&ensp;<code>dict</code></dt>
<dd>Dictionary containing the config parameters</dd>
</dl></section>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">class Network_Config(object):
    def __init__(self, model_dir = None, config_filepath = None, **kwargs):
        &#34;&#34;&#34;Creates Network_Config object that contains the network parameters and functions needed to manipulate these parameters.
    
        Parameters
        ----------
        model_dir : `str`, optional
            [Default: None] Folder where the model is to be saved/read from
        config_filepath : `str`, optional
            [Default: None] Filepath to the config file that will be loaded
        **kwargs
            For network parameters that are to be changed from the loaded config file

        Attributes
        ----------
        yaml : :class:`ruamel.yaml.YAML`
            YAML class with function needed to read/write YAML files 
        config : `dict`
            Dictionary containing the config parameters
        &#34;&#34;&#34;
        self.yaml=YAML()
        
        # load config file from model_dir
        if config_filepath is not None:
            
            self.config = self.load_config_from_file(config_filepath)
            print(&#34;Loaded config file from {}&#34;.format(config_filepath))
        elif model_dir is not None:
            try:
                self.config = self.load_config_from_model_dir(model_dir)
                print(&#34;Loaded config file from {}&#34;.format(model_dir))
            except:
                print(&#34;Please ensure that config_filepath is set or there is a config file in model_dir&#34;)
                raise
            
        if model_dir is not None:
            # update model_dir in config
            print(&#34;Updating model_dir to {}&#34;.format(model_dir))
            self.update_parameter([&#34;general&#34;, &#34;model_dir&#34;], model_dir)
        
        # overwrite network parameters with parameters given during initialization
        for key, value in kwargs.items():
            self.update_parameter(self.find_key(key), value)
            
        # perform calculations
        self.update_parameter([&#34;model&#34;, &#34;input_size&#34;], self.get_parameter(&#34;tile_size&#34;) + [self.get_parameter(&#34;image_channel&#34;),])
        self.update_parameter([&#34;model&#34;, &#34;batch_size&#34;], self.get_parameter(&#34;batch_size_per_GPU&#34;)) # * self.gpu_count
                  
    ######################
    # Accessors/Mutators
    ######################
    def get_parameter(self, parameter, config = []):
        &#34;&#34;&#34;Output the value from the config file using the given key

        Parameters
        ----------
        parameter : `list` or `str`
            Key or list of keys used to find for the value in the config file
        
        config : `list`, optional
            Used to iterate through nested dictionaries. Required to recursively iterate through neseted dictionary
            
        Returns
        ----------
        value : `str` or `int` or `list`
            Value obtained from the specified key
            
        See Also
        ----------
        find_key : Function to identify the list of keys to address the correct item in a nested dictionary
        &#34;&#34;&#34;
        assert isinstance(parameter, (list, str))
        
        # find for key in nested dictionary
        if isinstance(parameter, str):
            parameter = self.find_key(parameter)
        
        if config == []:
            config = self.config
        if config is None:
            return None
        
        if not parameter:
            return config
        
        return self.get_parameter(parameter[1:], config = config.get(parameter[0]))

    def update_parameter(self, parameter, value, config = None):
        &#34;&#34;&#34;Updates the parameter in the config file using a full addressed list

        Parameters
        ----------
        parameter : `list`
            List of keys that point to the correct item in the nested dictionary
            
        value : `str` or `int` or `list`
            Value that is updated in the nested dictionary
            
        config : `list` or `none`, optional
            Used to iterate through nested dictionaries
            
        Returns
        ----------
        TODO
        &#34;&#34;&#34;
        
        assert type(parameter) is list
                
        if config == None:
            config = self.config
        
        if len(parameter) == 1:
            config.update({parameter[0]: value})
            return config
        return self.update_parameter(parameter[1:], value, config = self.config.get(parameter[0]))

    def find_key(self, key, config = None):
        &#34;&#34;&#34;Find the list of keys to address the correct item in a nested dictionary

        Parameters
        ----------
        key : `str`
            Key that needs to be correctly addressed in a nested dictionary
            
        config : `list` or `none`, optional
            Used to iterate through nested dictionaries
            
        Returns
        ----------
        key : `list`
            Address of the key in the nested dictionary
        &#34;&#34;&#34;
        
        if config == None:
            config = self.config
            
        key_path = []
        for k, v in config.items():
            if k == key:
                return [k]
            elif isinstance(v, dict):
                found_key = self.find_key(key, config = v)
                if found_key is not None:
                    return [k] + found_key
    
    ######################
    # Config IO options
    ######################
    def load_config_from_file(self, file_path):
        &#34;&#34;&#34;Load parameters from yaml file

        Parameters
        ----------
        file_path : `str`
            Path of config file to load
            
        Returns
        ----------
        config : `dict`
            Dictionary containing the config parameters
        &#34;&#34;&#34;

        with open(file_path, &#39;r&#39;) as input_file: 
            config = self.yaml.load(input_file)
            input_file.close()

        return config
    
    def load_config_from_model_dir(self, model_dir):
        &#34;&#34;&#34;Finds for a config file from the model directory and loads it
    
        Parameters
        ----------
        model_dir : `str`
            Folder to search for and load the config file

        Returns
        ----------
        config : `dict`
            Dictionary containing the config parameters
            
        Raises
        ------
        IndexError
            If there are no config file in the model_dir
        &#34;&#34;&#34;
        
        # check if yaml file exists in model_dir
        try:
            list_config_files = glob.glob(os.path.join(model_dir,&#39;*config.yml&#39;))
            if len(list_config_files) &gt; 1:
                print(&#34;Multiple config files found. Loading {}&#34;.format(list_config_files[0]))
            else:
                print(&#34;Config file exists in model directory. Loading {}&#34;.format(list_config_files[0]))
            return self.load_config_from_file(list_config_files[0])
        except IndexError:
            print(&#34;No config file found in model_dir.&#34;)
            raise

    def write_config(self, file_path):
        &#34;&#34;&#34;Writes parameters to yaml file

        Parameters
        ----------
        file_path : `str`
            Path of config file to write to
        &#34;&#34;&#34;
        
        with open(file_path, &#39;w&#39;) as output_file:  
            self.yaml.dump(self.config, output_file)

        output_file.close()
        
        print(&#34;Config file written to: {}&#34;.format(file_path))
    
    def write_model(self, model, file_path):
        &#34;&#34;&#34;Writes parameters to yaml file

        Parameters
        ----------
        model : :class:`Keras.model`
            Keras model that will be parsed and written to a yaml file
        
        file_path : `str`
            Path of model file to write to
        &#34;&#34;&#34;
        
        with open(file_path, &#39;w&#39;) as output_file:  
            output_file.write(model.to_yaml())

        output_file.close()
        
        print(&#34;Model file written to: {}&#34;.format(file_path))</code></pre>
</details>
<h3>Methods</h3>
<dl>
<dt id="models.internals.network_config.Network_Config.find_key"><code class="name flex">
<span>def <span class="ident">find_key</span></span>(<span>self, key, config=None)</span>
</code></dt>
<dd>
<section class="desc"><p>Find the list of keys to address the correct item in a nested dictionary</p>
<h2 id="parameters">Parameters</h2>
<dl>
<dt><strong><code>key</code></strong> :&ensp;<code>str</code></dt>
<dd>Key that needs to be correctly addressed in a nested dictionary</dd>
<dt><strong><code>config</code></strong> :&ensp;<code>list</code> or <code>none</code>, optional</dt>
<dd>Used to iterate through nested dictionaries</dd>
</dl>
<h2 id="returns">Returns</h2>
<dl>
<dt><strong><code>key</code></strong> :&ensp;<code>list</code></dt>
<dd>Address of the key in the nested dictionary</dd>
</dl></section>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">def find_key(self, key, config = None):
    &#34;&#34;&#34;Find the list of keys to address the correct item in a nested dictionary

    Parameters
    ----------
    key : `str`
        Key that needs to be correctly addressed in a nested dictionary
        
    config : `list` or `none`, optional
        Used to iterate through nested dictionaries
        
    Returns
    ----------
    key : `list`
        Address of the key in the nested dictionary
    &#34;&#34;&#34;
    
    if config == None:
        config = self.config
        
    key_path = []
    for k, v in config.items():
        if k == key:
            return [k]
        elif isinstance(v, dict):
            found_key = self.find_key(key, config = v)
            if found_key is not None:
                return [k] + found_key</code></pre>
</details>
</dd>
<dt id="models.internals.network_config.Network_Config.get_parameter"><code class="name flex">
<span>def <span class="ident">get_parameter</span></span>(<span>self, parameter, config=[])</span>
</code></dt>
<dd>
<section class="desc"><p>Output the value from the config file using the given key</p>
<h2 id="parameters">Parameters</h2>
<dl>
<dt><strong><code>parameter</code></strong> :&ensp;<code>list</code> or <code>str</code></dt>
<dd>Key or list of keys used to find for the value in the config file</dd>
<dt><strong><code>config</code></strong> :&ensp;<code>list</code>, optional</dt>
<dd>Used to iterate through nested dictionaries. Required to recursively iterate through neseted dictionary</dd>
</dl>
<h2 id="returns">Returns</h2>
<dl>
<dt><strong><code>value</code></strong> :&ensp;<code>str</code> or <code>int</code> or <code>list</code></dt>
<dd>Value obtained from the specified key</dd>
</dl>
<h2 id="see-also">See Also</h2>
<dl>
<dt><code>find_key</code></dt>
<dd>Function to identify the list of keys to address the correct item in a nested dictionary</dd>
</dl></section>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">def get_parameter(self, parameter, config = []):
    &#34;&#34;&#34;Output the value from the config file using the given key

    Parameters
    ----------
    parameter : `list` or `str`
        Key or list of keys used to find for the value in the config file
    
    config : `list`, optional
        Used to iterate through nested dictionaries. Required to recursively iterate through neseted dictionary
        
    Returns
    ----------
    value : `str` or `int` or `list`
        Value obtained from the specified key
        
    See Also
    ----------
    find_key : Function to identify the list of keys to address the correct item in a nested dictionary
    &#34;&#34;&#34;
    assert isinstance(parameter, (list, str))
    
    # find for key in nested dictionary
    if isinstance(parameter, str):
        parameter = self.find_key(parameter)
    
    if config == []:
        config = self.config
    if config is None:
        return None
    
    if not parameter:
        return config
    
    return self.get_parameter(parameter[1:], config = config.get(parameter[0]))</code></pre>
</details>
</dd>
<dt id="models.internals.network_config.Network_Config.load_config_from_file"><code class="name flex">
<span>def <span class="ident">load_config_from_file</span></span>(<span>self, file_path)</span>
</code></dt>
<dd>
<section class="desc"><p>Load parameters from yaml file</p>
<h2 id="parameters">Parameters</h2>
<dl>
<dt><strong><code>file_path</code></strong> :&ensp;<code>str</code></dt>
<dd>Path of config file to load</dd>
</dl>
<h2 id="returns">Returns</h2>
<dl>
<dt><strong><code>config</code></strong> :&ensp;<code>dict</code></dt>
<dd>Dictionary containing the config parameters</dd>
</dl></section>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">def load_config_from_file(self, file_path):
    &#34;&#34;&#34;Load parameters from yaml file

    Parameters
    ----------
    file_path : `str`
        Path of config file to load
        
    Returns
    ----------
    config : `dict`
        Dictionary containing the config parameters
    &#34;&#34;&#34;

    with open(file_path, &#39;r&#39;) as input_file: 
        config = self.yaml.load(input_file)
        input_file.close()

    return config</code></pre>
</details>
</dd>
<dt id="models.internals.network_config.Network_Config.load_config_from_model_dir"><code class="name flex">
<span>def <span class="ident">load_config_from_model_dir</span></span>(<span>self, model_dir)</span>
</code></dt>
<dd>
<section class="desc"><p>Finds for a config file from the model directory and loads it</p>
<h2 id="parameters">Parameters</h2>
<dl>
<dt><strong><code>model_dir</code></strong> :&ensp;<code>str</code></dt>
<dd>Folder to search for and load the config file</dd>
</dl>
<h2 id="returns">Returns</h2>
<dl>
<dt><strong><code>config</code></strong> :&ensp;<code>dict</code></dt>
<dd>Dictionary containing the config parameters</dd>
</dl>
<h2 id="raises">Raises</h2>
<dl>
<dt><code>IndexError</code></dt>
<dd>If there are no config file in the model_dir</dd>
</dl></section>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">def load_config_from_model_dir(self, model_dir):
    &#34;&#34;&#34;Finds for a config file from the model directory and loads it

    Parameters
    ----------
    model_dir : `str`
        Folder to search for and load the config file

    Returns
    ----------
    config : `dict`
        Dictionary containing the config parameters
        
    Raises
    ------
    IndexError
        If there are no config file in the model_dir
    &#34;&#34;&#34;
    
    # check if yaml file exists in model_dir
    try:
        list_config_files = glob.glob(os.path.join(model_dir,&#39;*config.yml&#39;))
        if len(list_config_files) &gt; 1:
            print(&#34;Multiple config files found. Loading {}&#34;.format(list_config_files[0]))
        else:
            print(&#34;Config file exists in model directory. Loading {}&#34;.format(list_config_files[0]))
        return self.load_config_from_file(list_config_files[0])
    except IndexError:
        print(&#34;No config file found in model_dir.&#34;)
        raise</code></pre>
</details>
</dd>
<dt id="models.internals.network_config.Network_Config.update_parameter"><code class="name flex">
<span>def <span class="ident">update_parameter</span></span>(<span>self, parameter, value, config=None)</span>
</code></dt>
<dd>
<section class="desc"><p>Updates the parameter in the config file using a full addressed list</p>
<h2 id="parameters">Parameters</h2>
<dl>
<dt><strong><code>parameter</code></strong> :&ensp;<code>list</code></dt>
<dd>List of keys that point to the correct item in the nested dictionary</dd>
<dt><strong><code>value</code></strong> :&ensp;<code>str</code> or <code>int</code> or <code>list</code></dt>
<dd>Value that is updated in the nested dictionary</dd>
<dt><strong><code>config</code></strong> :&ensp;<code>list</code> or <code>none</code>, optional</dt>
<dd>Used to iterate through nested dictionaries</dd>
</dl>
<h2 id="returns">Returns</h2>
<dl>
<dt><code>TODO</code></dt>
<dd>&nbsp;</dd>
</dl></section>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">def update_parameter(self, parameter, value, config = None):
    &#34;&#34;&#34;Updates the parameter in the config file using a full addressed list

    Parameters
    ----------
    parameter : `list`
        List of keys that point to the correct item in the nested dictionary
        
    value : `str` or `int` or `list`
        Value that is updated in the nested dictionary
        
    config : `list` or `none`, optional
        Used to iterate through nested dictionaries
        
    Returns
    ----------
    TODO
    &#34;&#34;&#34;
    
    assert type(parameter) is list
            
    if config == None:
        config = self.config
    
    if len(parameter) == 1:
        config.update({parameter[0]: value})
        return config
    return self.update_parameter(parameter[1:], value, config = self.config.get(parameter[0]))</code></pre>
</details>
</dd>
<dt id="models.internals.network_config.Network_Config.write_config"><code class="name flex">
<span>def <span class="ident">write_config</span></span>(<span>self, file_path)</span>
</code></dt>
<dd>
<section class="desc"><p>Writes parameters to yaml file</p>
<h2 id="parameters">Parameters</h2>
<dl>
<dt><strong><code>file_path</code></strong> :&ensp;<code>str</code></dt>
<dd>Path of config file to write to</dd>
</dl></section>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">def write_config(self, file_path):
    &#34;&#34;&#34;Writes parameters to yaml file

    Parameters
    ----------
    file_path : `str`
        Path of config file to write to
    &#34;&#34;&#34;
    
    with open(file_path, &#39;w&#39;) as output_file:  
        self.yaml.dump(self.config, output_file)

    output_file.close()
    
    print(&#34;Config file written to: {}&#34;.format(file_path))</code></pre>
</details>
</dd>
<dt id="models.internals.network_config.Network_Config.write_model"><code class="name flex">
<span>def <span class="ident">write_model</span></span>(<span>self, model, file_path)</span>
</code></dt>
<dd>
<section class="desc"><p>Writes parameters to yaml file</p>
<h2 id="parameters">Parameters</h2>
<dl>
<dt><strong><code>model</code></strong> :&ensp;:<code>class</code>:<code>Keras.model</code></dt>
<dd>Keras model that will be parsed and written to a yaml file</dd>
<dt><strong><code>file_path</code></strong> :&ensp;<code>str</code></dt>
<dd>Path of model file to write to</dd>
</dl></section>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">def write_model(self, model, file_path):
    &#34;&#34;&#34;Writes parameters to yaml file

    Parameters
    ----------
    model : :class:`Keras.model`
        Keras model that will be parsed and written to a yaml file
    
    file_path : `str`
        Path of model file to write to
    &#34;&#34;&#34;
    
    with open(file_path, &#39;w&#39;) as output_file:  
        output_file.write(model.to_yaml())

    output_file.close()
    
    print(&#34;Model file written to: {}&#34;.format(file_path))</code></pre>
</details>
</dd>
</dl>
</dd>
</dl>
</section>
</article>
<nav id="sidebar">
<h1>Index</h1>
<div class="toc">
<ul></ul>
</div>
<ul id="index">
<li><h3>Super-module</h3>
<ul>
<li><code><a title="models.internals" href="index.html">models.internals</a></code></li>
</ul>
</li>
<li><h3><a href="#header-classes">Classes</a></h3>
<ul>
<li>
<h4><code><a title="models.internals.network_config.Network_Config" href="#models.internals.network_config.Network_Config">Network_Config</a></code></h4>
<ul class="">
<li><code><a title="models.internals.network_config.Network_Config.find_key" href="#models.internals.network_config.Network_Config.find_key">find_key</a></code></li>
<li><code><a title="models.internals.network_config.Network_Config.get_parameter" href="#models.internals.network_config.Network_Config.get_parameter">get_parameter</a></code></li>
<li><code><a title="models.internals.network_config.Network_Config.load_config_from_file" href="#models.internals.network_config.Network_Config.load_config_from_file">load_config_from_file</a></code></li>
<li><code><a title="models.internals.network_config.Network_Config.load_config_from_model_dir" href="#models.internals.network_config.Network_Config.load_config_from_model_dir">load_config_from_model_dir</a></code></li>
<li><code><a title="models.internals.network_config.Network_Config.update_parameter" href="#models.internals.network_config.Network_Config.update_parameter">update_parameter</a></code></li>
<li><code><a title="models.internals.network_config.Network_Config.write_config" href="#models.internals.network_config.Network_Config.write_config">write_config</a></code></li>
<li><code><a title="models.internals.network_config.Network_Config.write_model" href="#models.internals.network_config.Network_Config.write_model">write_model</a></code></li>
</ul>
</li>
</ul>
</li>
</ul>
</nav>
</main>
<footer id="footer">
<p>Generated by <a href="https://pdoc3.github.io/pdoc"><cite>pdoc</cite> 0.7.1</a>.</p>
</footer>
<script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/highlight.min.js"></script>
<script>hljs.initHighlightingOnLoad()</script>
</body>
</html>